/*
このファイルの中身は、NTT オープンソースライセンス　バージョン 1.0（「本
契約」という）の適用を受けます。
本契約を遵守しない限り、このファイルを使用してはなりません。
本契約のコピーは、次のＵＲＬから入手できます。
【配布サイトのURL】 http://www.oss.ecl.ntt.co.jp/lms/

本契約に基づき頒布されるソフトウェアは、現状のまま、明示又は黙示のあらゆ
る種類の保証なしで、頒布されます。本契約に基づく権利及び制限を律する特定
の文言については、本契約を参照してください。

「オリジナルコード」は、 NTT Cyber Space Laboratories Code です。 
「オリジナルコード」の「初期開発者」は、日本電信電話株式会社です。  
日本電信電話株式会社により創作された部分は、Copyright (C) 2004 
日本電信電話株式会社 です。
全ての権利が留保されます。 
「コントリビュータ」：_____________________________________ 


The contents of this file are subject to the NTT Opensource License
Version 1.0 (the License); you may not use this file except in
compliance with the License. You may obtain a copy of the License at
【配布サイトのURL】 http://www.oss.ecl.ntt.co.jp/lms/

Software distributed under the License is distributed on an AS IS
basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
License for the specific language governing rights and limitations
under the License.

The Original Code is NTT Cyber Space Laboratories Code .

The Initial Developer of the Original Code is NIPPON TELEGRAPH AND 
TELEPHONE CORPORATION.
Portions created by the NIPPON TELEGRAPH AND TELEPHONE CORPORATION 
are Copyright (C) 2004 NIPPON TELEGRAPH AND TELEPHONE CORPORATION. 
All Rights Reserved.

Contributor(s) ______________________________________.
*/

//
//	学習管理クラスタイプ２
// 【共通ログ登録・更新パターン】
// ----------------------------------
// 登録項目(1回目の学習開始)
// ・UserID
// ・LOID
// ・study_start_date(学習開始日付)
// ・residanceTime(null)
// ・passday(null)
// ・study_end_date(null)
// ・highScore(null)
// ・lowsScore(null)
// ・execise_point(null)
// ・fullscore(null)
// ・Access_cnt(1)
// ・last_access(学習開始日付)
// ----------------------------------
// 更新項目(2回目の学習開始)
// ・Access_cnt(更新前の値 + 1)
// ・last_access(学習開始日付)
// ----------------------------------
//			変更履歴
// 2004.01.08 新規作成 suzuki 
//

package jp.co.ntt.lms.lo;

import jp.co.ntt.lms.lo.*;
import jp.co.ntt.lms.xmo.util.*;
import jp.co.ntt.lms.xmo.*;
import jp.co.ntt.lms.Common.status.*;
import jp.co.ntt.lms.xmo.Lo.LoClient;

import java.util.Hashtable;
import java.util.Vector;
import java.net.URLEncoder;
import java.sql.SQLException;

/**
 * 学習管理の共通親クラス
 * 学習終了時にステータスが決定するLOのログ更新処理を実装します。
 *
 */
public class LearnManagerType2
	implements LearnManager, LoPropertyDef
{
	/**
	 * 学習開始処理
	 *
	 * @param Hashtabel パラメータリスト
	 * @return Object 学習開始URL
	 * @exception LOException LO固有の例外エラー
	 */
	public Object startLearn(Hashtable htbParam, DataAccess objDataAccess)
		throws LOException
	{
		// ログ出力処理を実行します。
		startUpdateLog(htbParam, objDataAccess);
		
		// 学習開始処理を実行します。
		return startLearnAction(htbParam, objDataAccess);
	}

	/**
	 * 学習終了処理
	 *
	 * @param Hashtabel パラメータリスト
	 * @return Object NULL
	 * @exception LOException Lo固有の例外エラー
	 */
	public Object endLearn(Hashtable htbParam, DataAccess objDataAccess)
		throws LOException
	{
		// 学習終了処理を実行します。
		return endLearnAction(htbParam, objDataAccess);
	}
	
	/**
	 * 学習開始時のログ出力処理を実行します。
	 */
	protected void startUpdateLog(Hashtable htbParam, DataAccess objDataAccess)
		throws LOException
	{
		try
		{
			String strUserID = (String)htbParam.get(USER);
			String strLoID = (String)htbParam.get(LOID);

			// 本日日付の取得
			String strNow = XMODate.parseTime( new java.util.Date() );

			///////////////////////////////////////////////////////////////
			// LoLogステータスログテーブルの更新処理
			///////////////////////////////////////////////////////////////
			LoLogDataAccess objLoLogDataAccess = new LoLogDataAccess();

			// XMS2のDBからデータ取得
			LoLogRecord objDbData = objLoLogDataAccess.getLoLog(strUserID,
																 strLoID,
																 objDataAccess);
			
			if( objDbData == null )
			{
				// レコードがない場合
				objDbData = new LoLogRecord();
			}

			// ユーザIDの設定
			objDbData.setUserID( strUserID );
			// LOIDの設定
			objDbData.setLoID( strLoID );

			if( objDbData.getStudyStartDate() == null ||
				objDbData.getStudyStartDate().equals( "" ) )
			{
				// 初めて学習する場合、開始日付の設定
				objDbData.setStudyStartDate( strNow );
			}

			// アクセス回数設定
			long lngAccessCnt = 0;
			if( objDbData.getAccessCnt() == null ||
				objDbData.getAccessCnt().equals( "" ) )
			{
				// 初めて学習する場合、1を設定
				objDbData.setAccessCnt("1");
			}
			else
			{
				// 2回目以降に学習する場合、前回までのアクセス回数に＋１して設定
				lngAccessCnt = new Float( objDbData.getAccessCnt() ).longValue() + 1;
				objDbData.setAccessCnt( lngAccessCnt + "" );
			}
			
			// 最終アクセス日時設定
			objDbData.setLastAccess( strNow );

			// ステータスログの登録または更新を行います
			objLoLogDataAccess.insertUpdate(	objDbData,
												strUserID,
												strLoID,
												objDataAccess );

			// 参照LOIDリストを取得します
			LoClient objLoClient = new LoClient();
			if(!objLoClient.getListFromRealLOID( strLoID )){
				new LOException("参照LOIDリストの取得失敗しました。");
			}
			String[] strRefList = objLoClient.getRefListResult();
			// 参照リスト分ステータス伝播
			for(int i = 0; i < strRefList.length; i++){
				//ステータス伝搬処理
				StatusPropagation objStatus = new StatusPropagation( strUserID, strRefList[i] );
				PropagateControl.getInstance().addPropagate(objStatus);
			}

		}
		catch(SQLException se)
		{
			DebugLog.write( this.getClass(), se, DebugLog.HIGHT );
			throw new LOException( se.getMessage() );
		}
		catch(Exception e)
		{
			DebugLog.write( this.getClass(), e, DebugLog.HIGHT );
			throw new LOException(e.getMessage());
		}
	}
	
	/**
	 * 学習開始処理を実行します。
	 */
	protected Object startLearnAction(Hashtable htbParam, DataAccess objDataAccess)
		throws LOException
	{
		return null;
	}
	
	/**
	 * 学習終了処理を実行します。
	 */
	protected Object endLearnAction(Hashtable htbParam, DataAccess objDataAccess)
		throws LOException
	{
		return null;
	}
	
}
